xfs: fix more xfs_db open-coding instances
[xfstests-dev.git] / tests / xfs / 148
1 #! /bin/bash
2 # FS QA Test No. 148
3 #
4 # Exercise xfs parallel repair on broken filesystems
5 # This is a clone of test 030 useing xfs_prepair64 instead of xfs_repair
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25
26 seq=`basename $0`
27 seqres=$RESULT_DIR/$seq
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1        # failure is the default!
33
34 _cleanup()
35 {
36         cd /
37         _scratch_unmount 2>/dev/null
38         rm -f $tmp.*
39 }
40
41 trap "_cleanup; exit \$status" 0 1 2 3 15
42
43 # get standard environment, filters and checks
44 . ./common/rc
45 . ./common/filter
46 . ./common/repair
47
48 [ -z "$XFS_PARALLEL_REPAIR64_PROG" ] && _notrun "parallel repair binary xfs_prepair64 is not installed"
49
50 # force use of parallel repair
51 export XFS_REPAIR_PROG=$XFS_PARALLEL_REPAIR64_PROG
52
53 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
54
55 _check_ag()
56 {
57         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
58         do
59                 echo "Corrupting $structure - setting bits to $1"
60                 _check_repair $1 "$structure"
61         done
62 }
63
64 # real QA test starts here
65 _supported_fs xfs
66 _supported_os IRIX Linux
67
68 _require_scratch
69 _require_no_large_scratch_dev
70
71 DSIZE="-dsize=100m"
72
73 # first we need to ensure there are no bogus secondary
74 # superblocks between the primary and first secondary
75 # superblock (hanging around from earlier tests)...
76 #
77
78 _scratch_mkfs_xfs $DSIZE >/dev/null 2>&1
79 if [ $? -ne 0 ]         # probably don't have a big enough scratch
80 then
81         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
82 else
83         _scratch_mount
84         src/feature -U $SCRATCH_DEV && \
85                 _notrun "UQuota are enabled, test needs controlled sb recovery"
86         src/feature -G $SCRATCH_DEV && \
87                 _notrun "GQuota are enabled, test needs controlled sb recovery"
88         src/feature -P $SCRATCH_DEV && \
89                 _notrun "PQuota are enabled, test needs controlled sb recovery"
90         _scratch_unmount
91 fi
92 clear=""
93 eval `xfs_db -r -c "sb 1" -c stack $SCRATCH_DEV | $PERL_PROG -ne '
94         if (/byte offset (\d+), length (\d+)/) {
95                 print "clear=", $1 / 512, "\n"; exit
96         }'`
97 [ -z "$clear" ] && echo "Cannot calculate length to clear"
98 src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
99
100 # now kick off the real prepair test...
101 #
102 _scratch_mkfs_xfs $DSIZE | _filter_mkfs 2>$tmp.mkfs
103 . $tmp.mkfs
104 _check_ag 0
105 _check_ag -1
106
107 # success, all done
108 status=0
109 exit